PRINT "Clyde's Revenge Extractor by Frenkel Smeijers, Version 2, 26-Jun-2004."

OPEN "C2.db" FOR BINARY AS #1
IF LOF(1) = 0 THEN
  PRINT "Can't find C2.DB. Make sure you've put this"
  PRINT "program in your Clyde's Revenge directory."
  CLOSE #1
  KILL "c2.db"
  END
END IF

CONST constbuffersize = 20000
DIM constbuffer AS STRING * constbuffersize

TYPE headertype
  filename1 AS STRING * 16
  offset AS LONG
  length1 AS LONG
END TYPE

DIM headeritem AS headertype

GET #1, , nroffiles&

FOR x& = 0 TO nroffiles& - 1
  GET #1, x& * 24 + 5, headeritem
  
  z% = 1
  filename2$ = ""
  DO WHILE ASC(MID$(headeritem.filename1, z%, 1))' <> 0
    filename2$ = filename2$ + MID$(headeritem.filename1, z%, 1)
    z% = z% + 1
  LOOP

  OPEN filename2$ FOR BINARY AS #2
 
  SEEK #1, headeritem.offset + 1
  length2& = headeritem.length1
 
  'Get and put big chunks
  DO WHILE length2& >= constbuffersize
    GET #1, , constbuffer
    PUT #2, , constbuffer
    length2& = length2& - constbuffersize
  LOOP
 
  'Get and put the last and little chunk
  buffer$ = SPACE$(length2&)
  GET #1, , buffer$
  PUT #2, , buffer$
 
  CLOSE #2
  PRINT filename2$ + " written"
 
NEXT x&

CLOSE #1
PRINT nroffiles&; " files written."
END

